Index: /BAORadio/libindi/libindi/libs/indicom.c
===================================================================
--- /BAORadio/libindi/libindi/libs/indicom.c	(revision 500)
+++ /BAORadio/libindi/libindi/libs/indicom.c	(revision 501)
@@ -24,12 +24,4 @@
 */
 
-/* needed for sincos() in math.h */
-#ifndef _GNU_SOURCE
-#define _GNU_SOURCE
-#endif
-#ifdef _WIN32
-#define CX _CX
-#define CY _CY
-#endif
 #include <stdlib.h>
 #include <math.h>
@@ -40,11 +32,11 @@
 #include <errno.h>
 #include <stdarg.h>
-
-#include <config.h>
+#include <sys/param.h>
+
+//#include <config.h>
 
 #ifdef HAVE_NOVA_H
 #include <libnova.h>
 #endif
-
 
 #include "indicom.h"
@@ -52,11 +44,4 @@
 #undef CX
 #undef CY
-#endif
-const char * Direction[] = { "North", "West", "East", "South", "All"};
-const char * SolarSystem[] = { "Mercury", "Venus", "Moon", "Mars", "Jupiter", "Saturn", "Uranus", "Neptune", "Pluto"};
-
-/* make it compile on solaris */
-#ifndef M_PI
-#define M_PI 3.14159265358979323846264338327950288419716939937510582097494459
 #endif
 
@@ -67,4 +52,8 @@
 #define PARITY_ODD     2
 #endif
+
+#define MAXRBUF         2048
+
+#include "indidevapi.h"
 
 void getSexComponents(double value, int *d, int *m, int *s);
@@ -387,4 +376,284 @@
 }
 
+#ifdef BSD
+// BSD - OSX version
+int tty_connect(const char *device, int bit_rate, int word_size, int parity, int stop_bits, int *fd)
+{
+       int	t_fd = -1;
+       int bps;
+       char msg[80];
+    int	handshake;
+    struct termios	tty_setting;
+
+    // Open the serial port read/write, with no controlling terminal, and don't wait for a connection.
+    // The O_NONBLOCK flag also causes subsequent I/O on the device to be non-blocking.
+    // See open(2) ("man 2 open") for details.
+
+    t_fd = open(device, O_RDWR | O_NOCTTY | O_NONBLOCK);
+    if (t_fd == -1)
+    {
+        printf("Error opening serial port %s - %s(%d).\n",
+               device, strerror(errno), errno);
+        goto error;
+    }
+
+    // Note that open() follows POSIX semantics: multiple open() calls to the same file will succeed
+    // unless the TIOCEXCL ioctl is issued. This will prevent additional opens except by root-owned
+    // processes.
+    // See tty(4) ("man 4 tty") and ioctl(2) ("man 2 ioctl") for details.
+
+    if (ioctl(t_fd, TIOCEXCL) == -1)
+    {
+        printf("Error setting TIOCEXCL on %s - %s(%d).\n",
+            device, strerror(errno), errno);
+        goto error;
+    }
+
+    // Now that the device is open, clear the O_NONBLOCK flag so subsequent I/O will block.
+    // See fcntl(2) ("man 2 fcntl") for details.
+
+    if (fcntl(t_fd, F_SETFL, 0) == -1)
+    {
+        printf("Error clearing O_NONBLOCK %s - %s(%d).\n",
+            device, strerror(errno), errno);
+        goto error;
+    }
+
+    // Get the current options and save them so we can restore the default settings later.
+    if (tcgetattr(t_fd, &tty_setting) == -1)
+    {
+        printf("Error getting tty attributes %s - %s(%d).\n",
+            device, strerror(errno), errno);
+        goto error;
+    }
+
+    // Set raw input (non-canonical) mode, with reads blocking until either a single character
+    // has been received or a one second timeout expires.
+    // See tcsetattr(4) ("man 4 tcsetattr") and termios(4) ("man 4 termios") for details.
+
+    cfmakeraw(&tty_setting);
+    tty_setting.c_cc[VMIN] = 1;
+    tty_setting.c_cc[VTIME] = 10;
+
+    // The baud rate, word length, and handshake options can be set as follows:
+        switch (bit_rate) {
+                case 0:
+                        bps = B0;
+                        break;
+                case 50:
+                        bps = B50;
+                        break;
+                case 75:
+                        bps = B75;
+                        break;
+                case 110:
+                        bps = B110;
+                        break;
+                case 134:
+                        bps = B134;
+                        break;
+                case 150:
+                        bps = B150;
+                        break;
+                case 200:
+                        bps = B200;
+                        break;
+                case 300:
+                        bps = B300;
+                        break;
+                case 600:
+                        bps = B600;
+                        break;
+                case 1200:
+                        bps = B1200;
+                        break;
+                case 1800:
+                        bps = B1800;
+                        break;
+                case 2400:
+                        bps = B2400;
+                        break;
+                case 4800:
+                        bps = B4800;
+                        break;
+                case 9600:
+                        bps = B9600;
+                        break;
+                case 19200:
+                        bps = B19200;
+                        break;
+                case 38400:
+                        bps = B38400;
+                        break;
+                case 57600:
+                        bps = B57600;
+                        break;
+                case 115200:
+                        bps = B115200;
+                        break;
+                case 230400:
+                        bps = B230400;
+                        break;
+                default:
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid bit rate.", bit_rate)  0)
+                                perror(NULL);
+                        else
+                                perror(msg);
+                        return TTY_PARAM_ERROR;
+        }
+
+     cfsetspeed(&tty_setting, bps);		// Set baud rate
+        /* word size */
+        switch (word_size) {
+                case 5:
+                        tty_setting.c_cflag |= CS5;
+                        break;
+                case 6:
+                        tty_setting.c_cflag |= CS6;
+                        break;
+                case 7:
+                        tty_setting.c_cflag |= CS7;
+                        break;
+                case 8:
+                        tty_setting.c_cflag |= CS8;
+                        break;
+                default:
+
+                        fprintf( stderr, "Default\n") ;
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid data bit count.", word_size)  0)
+                                perror(NULL);
+                        else
+                                perror(msg);
+
+                        return TTY_PARAM_ERROR;
+        }
+
+        /* parity */
+        switch (parity) {
+                case PARITY_NONE:
+                        break;
+                case PARITY_EVEN:
+                        tty_setting.c_cflag |= PARENB;
+                        break;
+                case PARITY_ODD:
+                        tty_setting.c_cflag |= PARENB | PARODD;
+                        break;
+                default:
+
+                        fprintf( stderr, "Default1\n") ;
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid parity selection value.", parity)  0)
+                                perror(NULL);
+                        else
+                                perror(msg);
+
+                        return TTY_PARAM_ERROR;
+        }
+
+        /* stop_bits */
+        switch (stop_bits) {
+                case 1:
+                        break;
+                case 2:
+                        tty_setting.c_cflag |= CSTOPB;
+                        break;
+                default:
+                        fprintf( stderr, "Default2\n") ;
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid stop bit count.", stop_bits)  0)
+                                perror(NULL);
+                        else
+                                perror(msg);
+
+                        return TTY_PARAM_ERROR;
+        }
+
+#if defined(MAC_OS_X_VERSION_10_4) && (MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4)
+       // Starting with Tiger, the IOSSIOSPEED ioctl can be used to set arbitrary baud rates
+       // other than those specified by POSIX. The driver for the underlying serial hardware
+       // ultimately determines which baud rates can be used. This ioctl sets both the input
+       // and output speed.
+
+       speed_t speed = 14400; // Set 14400 baud
+    if (ioctl(fileDescriptor, IOSSIOSPEED, &speed) == -1)
+    {
+        printf("Error calling ioctl(..., IOSSIOSPEED, ...) %s - %s(%d).\n",
+            bsdPath, strerror(errno), errno);
+    }
+#endif
+
+    // Cause the new options to take effect immediately.
+    if (tcsetattr(t_fd, TCSANOW, &tty_setting) == -1)
+    {
+        printf("Error setting tty attributes %s - %s(%d).\n",
+            device, strerror(errno), errno);
+        goto error;
+    }
+
+    // To set the modem handshake lines, use the following ioctls.
+    // See tty(4) ("man 4 tty") and ioctl(2) ("man 2 ioctl") for details.
+
+    if (ioctl(t_fd, TIOCSDTR) == -1) // Assert Data Terminal Ready (DTR)
+    {
+        printf("Error asserting DTR %s - %s(%d).\n",
+            device, strerror(errno), errno);
+    }
+
+    if (ioctl(t_fd, TIOCCDTR) == -1) // Clear Data Terminal Ready (DTR)
+    {
+        printf("Error clearing DTR %s - %s(%d).\n",
+            device, strerror(errno), errno);
+    }
+
+    handshake = TIOCM_DTR | TIOCM_RTS | TIOCM_CTS | TIOCM_DSR;
+    if (ioctl(t_fd, TIOCMSET, &handshake) == -1)
+    // Set the modem lines depending on the bits set in handshake
+    {
+        printf("Error setting handshake lines %s - %s(%d).\n",
+            device, strerror(errno), errno);
+    }
+
+    // To read the state of the modem lines, use the following ioctl.
+    // See tty(4) ("man 4 tty") and ioctl(2) ("man 2 ioctl") for details.
+
+    if (ioctl(t_fd, TIOCMGET, &handshake) == -1)
+    // Store the state of the modem lines in handshake
+    {
+        printf("Error getting handshake lines %s - %s(%d).\n",
+            device, strerror(errno), errno);
+    }
+
+    printf("Handshake lines currently set to %d\n", handshake);
+
+#if defined(MAC_OS_X_VERSION_10_3) && (MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_3)
+       unsigned long mics = 1UL;
+
+       // Set the receive latency in microseconds. Serial drivers use this value to determine how often to
+       // dequeue characters received by the hardware. Most applications don't need to set this value: if an
+       // app reads lines of characters, the app can't do anything until the line termination character has been
+       // received anyway. The most common applications which are sensitive to read latency are MIDI and IrDA
+       // applications.
+
+       if (ioctl(t_fd, IOSSDATALAT, &mics) == -1)
+       {
+               // set latency to 1 microsecond
+        printf("Error setting read latency %s - %s(%d).\n",
+            device, strerror(errno), errno);
+        goto error;
+       }
+#endif
+
+   *fd = t_fd;
+  /* return success */
+  return TTY_OK;
+
+    // Failure path
+error:
+    if (t_fd != -1)
+    {
+        close(t_fd);
+    }
+
+    return TTY_PORT_FAILURE;
+}
+#else
 int tty_connect(const char *device, int bit_rate, int word_size, int parity, int stop_bits, int *fd)
 {
@@ -577,4 +846,8 @@
 #endif
 }
+// Unix - Linux version
+
+#endif
+
 
 int tty_disconnect(int fd)
@@ -644,2 +917,234 @@
    }	
 }
+
+/* return static string corresponding to the given property or light state */
+const char *
+pstateStr (IPState s)
+{
+        switch (s) {
+        case IPS_IDLE:  return ("Idle");
+        case IPS_OK:    return ("Ok");
+        case IPS_BUSY:  return ("Busy");
+        case IPS_ALERT: return ("Alert");
+        default:
+            fprintf (stderr, "Impossible IPState %d\n", s);
+            exit(1);
+        }
+}
+
+/* crack string into IPState.
+ * return 0 if ok, else -1
+ */
+int
+crackIPState (const char *str, IPState *ip)
+{
+             if (!strcmp (str, "Idle"))  *ip = IPS_IDLE;
+        else if (!strcmp (str, "Ok"))    *ip = IPS_OK;
+        else if (!strcmp (str, "Busy"))  *ip = IPS_BUSY;
+        else if (!strcmp (str, "Alert")) *ip = IPS_ALERT;
+        else return (-1);
+        return (0);
+}
+
+/* crack string into ISState.
+ * return 0 if ok, else -1
+ */
+int
+crackISState (const char *str, ISState *ip)
+{
+             if (!strcmp (str, "On"))  *ip = ISS_ON;
+        else if (!strcmp (str, "Off")) *ip = ISS_OFF;
+        else return (-1);
+        return (0);
+}
+
+int
+crackIPerm (const char *str, IPerm *ip)
+{
+             if (!strcmp (str, "rw"))  *ip = IP_RW;
+        else if (!strcmp (str, "ro")) *ip = IP_RO;
+        else if (!strcmp (str, "wo")) *ip = IP_WO;
+        else return (-1);
+        return (0);
+}
+
+int crackISRule (const char *str, ISRule *ip)
+{
+    if (!strcmp (str, "OneOfMany"))  *ip = ISR_1OFMANY;
+    else if (!strcmp (str, "AtMostOne")) *ip = ISR_ATMOST1;
+    else if (!strcmp (str, "AnyOfMany")) *ip = ISR_NOFMANY;
+    else return (-1);
+  return (0);
+}
+
+/* return static string corresponding to the given switch state */
+const char *
+sstateStr (ISState s)
+{
+        switch (s) {
+        case ISS_ON:  return ("On");
+        case ISS_OFF: return ("Off");
+        default:
+            fprintf (stderr, "Impossible ISState %d\n", s);
+        }
+}
+
+/* return static string corresponding to the given Rule */
+const char *
+ruleStr (ISRule r)
+{
+        switch (r) {
+        case ISR_1OFMANY: return ("OneOfMany");
+        case ISR_ATMOST1: return ("AtMostOne");
+        case ISR_NOFMANY: return ("AnyOfMany");
+        default:
+            fprintf (stderr, "Impossible ISRule %d\n", r);
+        }
+}
+
+/* return static string corresponding to the given IPerm */
+const char *
+permStr (IPerm p)
+{
+        switch (p) {
+        case IP_RO: return ("ro");
+        case IP_WO: return ("wo");
+        case IP_RW: return ("rw");
+        default:
+            fprintf (stderr, "Impossible IPerm %d\n", p);
+        }
+}
+
+/* print the boilerplate comment introducing xml */
+void
+xmlv1()
+{
+        printf ("<?xml version='1.0'?>\n");
+}
+
+/* pull out device and name attributes from root.
+ * return 0 if ok else -1 with reason in msg[].
+ */
+int
+crackDN (XMLEle *root, char **dev, char **name, char msg[])
+{
+        XMLAtt *ap;
+
+        ap = findXMLAtt (root, "device");
+        if (!ap) {
+            sprintf (msg, "%s requires 'device' attribute", tagXMLEle(root));
+            return (-1);
+        }
+        *dev = valuXMLAtt(ap);
+
+        ap = findXMLAtt (root, "name");
+        if (!ap) {
+            sprintf (msg, "%s requires 'name' attribute", tagXMLEle(root));
+            return (-1);
+        }
+        *name = valuXMLAtt(ap);
+
+        return (0);
+}
+
+/* find a member of an IText vector, else NULL */
+IText *
+IUFindText  (const ITextVectorProperty *tvp, const char *name)
+{
+        int i;
+
+        for (i = 0; i < tvp->ntp; i++)
+            if (strcmp (tvp->tp[i].name, name) == 0)
+                return (&tvp->tp[i]);
+        fprintf (stderr, "No IText '%s' in %s.%s\n",name,tvp->device,tvp->name);
+        return (NULL);
+}
+
+/* find a member of an INumber vector, else NULL */
+INumber *
+IUFindNumber(const INumberVectorProperty *nvp, const char *name)
+{
+        int i;
+
+        for (i = 0; i < nvp->nnp; i++)
+            if (strcmp (nvp->np[i].name, name) == 0)
+                return (&nvp->np[i]);
+        fprintf(stderr,"No INumber '%s' in %s.%s\n",name,nvp->device,nvp->name);
+        return (NULL);
+}
+
+/* find a member of an ISwitch vector, else NULL */
+ISwitch *
+IUFindSwitch(const ISwitchVectorProperty *svp, const char *name)
+{
+        int i;
+
+        for (i = 0; i < svp->nsp; i++)
+            if (strcmp (svp->sp[i].name, name) == 0)
+                return (&svp->sp[i]);
+        fprintf(stderr,"No ISwitch '%s' in %s.%s\n",name,svp->device,svp->name);
+        return (NULL);
+}
+
+/* find a member of an ILight vector, else NULL */
+ILight *
+IUFindLight(const ILightVectorProperty *lvp, const char *name)
+{
+        int i;
+
+        for (i = 0; i < lvp->nlp; i++)
+            if (strcmp (lvp->lp[i].name, name) == 0)
+                return (&lvp->lp[i]);
+        fprintf(stderr,"No ILight '%s' in %s.%s\n",name,lvp->device,lvp->name);
+        return (NULL);
+}
+
+/* find a member of an IBLOB vector, else NULL */
+IBLOB *
+IUFindBLOB(const IBLOBVectorProperty *bvp, const char *name)
+{
+        int i;
+
+        for (i = 0; i < bvp->nbp; i++)
+            if (strcmp (bvp->bp[i].name, name) == 0)
+                return (&bvp->bp[i]);
+        fprintf(stderr,"No IBLOB '%s' in %s.%s\n",name,bvp->device,bvp->name);
+        return (NULL);
+}
+
+/* find an ON member of an ISwitch vector, else NULL.
+ * N.B. user must make sense of result with ISRule in mind.
+ */
+ISwitch *
+IUFindOnSwitch(const ISwitchVectorProperty *svp)
+{
+        int i;
+
+        for (i = 0; i < svp->nsp; i++)
+            if (svp->sp[i].s == ISS_ON)
+                return (&svp->sp[i]);
+        /*fprintf(stderr, "No ISwitch On in %s.%s\n", svp->device, svp->name);*/
+        return (NULL);
+}
+
+/* Set all switches to off */
+void
+IUResetSwitch(ISwitchVectorProperty *svp)
+{
+  int i;
+
+  for (i = 0; i < svp->nsp; i++)
+    svp->sp[i].s = ISS_OFF;
+}
+
+/* save malloced copy of newtext in tp->text, reusing if not first time */
+void
+IUSaveText (IText *tp, const char *newtext)
+{
+        /* seed for realloc */
+        if (tp->text == NULL)
+            tp->text = malloc (1);
+
+        /* copy in fresh string */
+        tp->text = strcpy (realloc (tp->text, strlen(newtext)+1), newtext);
+}
Index: /BAORadio/libindi/libindi/libs/lilxml.h
===================================================================
--- /BAORadio/libindi/libindi/libs/lilxml.h	(revision 500)
+++ /BAORadio/libindi/libindi/libs/lilxml.h	(revision 501)
@@ -248,9 +248,9 @@
 *   N.B. s must be at least as large as that reported by sprlXMLEle()+1.
 *   N.B. set level = 0 on first call.
-*   \return return length of resulting string (sans trailing \0)
+*   \return return length of resulting string (sans trailing @\0@)
 */
 extern int sprXMLEle (char *s, XMLEle *ep, int level);
 
-/** \brief return number of bytes in a string guaranteed able to hold result of sprXLMEle(ep) (sans trailing \0).
+/** \brief return number of bytes in a string guaranteed able to hold result of sprXLMEle(ep) (sans trailing @\0@).
 *   N.B. set level = 0 on first call.
 */
